---
- name: Validate if Kubernetes is installed
  become: true
  block:
    - name: Check if kubelet.conf exists
      ansible.builtin.stat:
        path: /etc/kubernetes/kubelet.conf
      register: kubelet_conf
      failed_when: not kubelet_conf.stat.exists

    - name: Check if kubelet service is up and running
      ansible.builtin.service:
        name: kubelet
        state: started
        enabled: true
      check_mode: true
      register: kubelet_service
      failed_when: kubelet_service.changed

    - name: Check if the node joined already  # noqa no-changed-when
      # using kubectl here as openshift et al. are otherwise not installed on worker nodes.
      # seems kinda excessive to deploy it just to check whether we need to join.
      environment:
        KUBECONFIG: /etc/kubernetes/kubelet.conf
      ansible.builtin.command:
      args:
        argv:
          - kubectl
          - get
          - node
          - "{{ inventory_hostname }}"

    - name: Set fact that it is
      ansible.builtin.set_fact:
        install_status: "k8s_installed"
  rescue:
    - name: Set fact that it is not
      ansible.builtin.set_fact:
        install_status: "k8s_not_installed"
...
